scala.tools.nsc.backend.opt.Inliners

# Inliner

###
Related Doc: package Inliners

#### class Inliner extends AnyRef

Simple inliner.

Source
  Inliners.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Inliner
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Inliner()

### Type Members

1. #### case class AccessReq(accessNeeded: NonPublicRefs.Value, toBecomePublic: List[Global.Symbol]) extends Product with Serializable

2. #### final class CallerCalleeInfo extends AnyRef

3. #### case class DontInlineHere(msg: String) extends InlineSafetyInfo with Product with Serializable

4. #### case class FeasibleInline(accessNeeded: NonPublicRefs.Value, toBecomePublic: List[Global.Symbol]) extends InlineSafetyInfo with Product with Serializable

5. #### class IMethodInfo extends AnyRef

6. #### sealed abstract class InlineSafetyInfo extends AnyRef

   Classifies a pair (caller, callee) into one of four categories:

   Classifies a pair (caller, callee) into one of four categories:

   (a) inlining should be performed, classified in turn into: (a.1) `InlineableAtThisCaller`: unconditionally at this caller (a.2) `FeasibleInline`: it only remains for certain access requirements to be met (see `IMethodInfo.accessRequirements()`)

   (b) inlining shouldn't be performed, classified in turn into: (b.1) `DontInlineHere`: indicates that this particular occurrence of the callee at the caller shouldn't be inlined.

   - Nothing is said about the outcome for other callers, or for other occurrences of the callee for the same caller.
   - In particular inlining might be possible, but heuristics gave a low score for it. (b.2) `NeverSafeToInline`: the callee can't be inlined anywhere, irrespective of caller.

   The classification above is computed by `isStampedForInlining()` based on which `analyzeInc()` goes on to:

   - either log the reason for failure --- case (b) ---,
   - or perform inlining --- case (a) ---.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Inliner to any2stringadd[Inliner] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Inliner, B)

   Implicit information
     This member is added by an implicit conversion from Inliner to ArrowAssoc[Inliner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object InlineableAtThisCaller extends InlineSafetyInfo with Product with Serializable

7. #### object NeverSafeToInline extends InlineSafetyInfo with Product with Serializable

8. #### object NonPublicRefs extends Enumeration

9. #### def analyzeClass(cls: Global.icodes.IClass): Unit

10. #### def analyzeMethod(m: Global.icodes.IMethod): Unit

    A transformation local to the body of the IMethod received as argument.

    A transformation local to the body of the IMethod received as argument. An inlining decision consists in replacing a callsite with the body of the callee. Please notice that, because `analyzeMethod()` itself may modify a method body, the particular callee bodies that end up being inlined depend on the particular order in which methods are visited (no topological sorting over the call-graph is attempted).

    Making an inlining decision requires type-flow information for both caller and callee. Regarding the caller, such information is needed only for basic blocks containing inlining candidates (and their transitive predecessors). This observation leads to using a custom type-flow analysis (MTFAGrowable) that can be re-inited, i.e. that reuses lattice elements (type-flow information computed in a previous iteration) as starting point for faster convergence in a new iteration.

    The mechanics of inlining are iterative for a given invocation of `analyzeMethod(m)`, and are affected by inlinings from previous iterations (ie, "heuristic" rules are based on statistics tracked for that purpose):

    (1) before the iterations proper start, so-called preinlining is performed. Those callsites whose (receiver, concreteMethod) are both known statically can be analyzed for inlining before computing a type-flow. Details in `preInline()`

    (2) the first iteration computes type-flow information for basic blocks containing inlining candidates (and their transitive predecessors), so called `relevantBBs` basic blocks. The ensuing analysis of each candidate (performed by `analyzeInc()`) may result in a CFG isomorphic to that of the callee being inserted in place of the callsite (i.e. a CALL_METHOD instruction is replaced with a single-entry single-exit CFG, a substitution we call "successful inlining").

    (3) following iterations have `relevantBBs` updated to focus on the inlined basic blocks and their successors only. Details in `MTFAGrowable.reinit()`

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

12. #### def clearCaches(): Unit

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

14. #### def ensuring(cond: (Inliner) ⇒ Boolean, msg: ⇒ Any): Inliner

    Implicit information
      This member is added by an implicit conversion from Inliner to Ensuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (Inliner) ⇒ Boolean): Inliner

    Implicit information
      This member is added by an implicit conversion from Inliner to Ensuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): Inliner

    Implicit information
      This member is added by an implicit conversion from Inliner to Ensuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): Inliner

    Implicit information
      This member is added by an implicit conversion from Inliner to Ensuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Inliner to StringFormat[Inliner] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

21. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

23. #### object imethodOrdering extends Ordering[Global.icodes.IMethod]

24. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

25. #### def lookupIMethod(meth: Global.Symbol, receiver: Global.Symbol): Option[Global.icodes.IMethod]

26. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

27. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

28. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

29. #### val recentTFAs: Map[Global.Symbol, (Boolean, Global.analysis.MethodTFA)]

30. #### def shouldLoadImplFor(sym: Global.Symbol, receiver: Global.Symbol): Boolean

    Should method 'sym' being called in 'receiver' be loaded from disk?

31. #### val splicedBlocks: Set[Global.icodes.BasicBlock]

32. #### val staleIn: Set[Global.icodes.BasicBlock]

33. #### val staleOut: ListBuffer[Global.icodes.BasicBlock]

34. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

35. #### val tfa: Global.analysis.MTFAGrowable

36. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

37. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### def →[B](y: B): (Inliner, B)

    Implicit information
      This member is added by an implicit conversion from Inliner to ArrowAssoc[Inliner] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Inliner to any2stringadd[Inliner]

### Inherited by implicit conversion StringFormat from Inliner to StringFormat[Inliner]

### Inherited by implicit conversion Ensuring from Inliner to Ensuring[Inliner]

### Inherited by implicit conversion ArrowAssoc from Inliner to ArrowAssoc[Inliner]

### Ungrouped